Given an array of n elements, the task is to find the greatest number such that it is the product of two elements of the given array. If no such element exists, print -1. Elements are within the range of 1 to 10^5.
Examples :
Input : arr[] = {10, 3, 5, 30, 35}
Output: 30
Explanation: 30 is the product of 10 and 3.
Input : arr[] = {2, 5, 7, 8}
Output: -1
Explanation: Since, no such element exists.
Input : arr[] = {10, 2, 4, 30, 35}
Output: -1
Input : arr[] = {10, 2, 2, 4, 30, 35}
Output: 4
Input : arr[] = {17, 2, 1, 35, 30}
Output : 35
A naive approach is to pick an element and then check for each pair product is equal to that number and update the max if the number is maximum, repeat until the whole array gets traversed takes O(n^3) time.
C++
#include<bits/stdc++.h>
using namespace std;
int findGreatest( int arr[] , int n)
{
int result = -1;
for ( int i = 0; i < n ; i++)
for ( int j = 0; j < n-1; j++)
for ( int k = j+1 ; k < n ; k++)
if (arr[j] * arr[k] == arr[i])
result = max(result, arr[i]);
return result;
}
int main()
{
int arr[] = {10, 3, 5, 30, 35};
int n = sizeof (arr)/ sizeof (arr[0]);
cout << findGreatest(arr, n);
return 0;
}
|
Java
import java.io.*;
class GFG{
static int findGreatest( int []arr , int n)
{
int result = - 1 ;
for ( int i = 0 ; i < n ; i++)
for ( int j = 0 ; j < n- 1 ; j++)
for ( int k = j+ 1 ; k < n ; k++)
if (arr[j] * arr[k] == arr[i])
result = Math.max(result, arr[i]);
return result;
}
static public void main (String[] args)
{
int []arr = { 10 , 3 , 5 , 30 , 35 };
int n = arr.length;
System.out.println(findGreatest(arr, n));
}
}
|
Python 3
def findGreatest( arr , n):
result = - 1
for i in range (n):
for j in range (n - 1 ):
for k in range (j + 1 , n):
if (arr[j] * arr[k] = = arr[i]):
result = max (result, arr[i])
return result
if __name__ = = "__main__" :
arr = [ 10 , 3 , 5 , 30 , 35 ]
n = len (arr)
print (findGreatest(arr, n))
|
C#
using System;
class GFG{
static int findGreatest( int []arr , int n)
{
int result = -1;
for ( int i = 0; i < n ; i++)
for ( int j = 0; j < n-1; j++)
for ( int k = j+1 ; k < n ; k++)
if (arr[j] * arr[k] == arr[i])
result = Math.Max(result, arr[i]);
return result;
}
static public void Main ()
{
int []arr = {10, 3, 5, 30, 35};
int n = arr.Length;
Console.WriteLine(findGreatest(arr, n));
}
}
|
PHP
<?php
function findGreatest( $arr , $n )
{
$result = -1;
for ( $i = 0; $i < $n ; $i ++)
for ( $j = 0; $j < $n - 1; $j ++)
for ( $k = $j + 1 ; $k < $n ; $k ++)
if ( $arr [ $j ] * $arr [ $k ] == $arr [ $i ])
$result = max( $result , $arr [ $i ]);
return $result ;
}
$arr = array (10, 3, 5, 30, 35);
$n = count ( $arr );
echo findGreatest( $arr , $n );
?>
|
Javascript
<script>
function findGreatest(arr , n)
{
let result = -1;
for (let i = 0; i < n ; i++)
for (let j = 0; j < n-1; j++)
for (let k = j+1 ; k < n ; k++)
if (arr[j] * arr[k] == arr[i])
result = Math.max(result, arr[i]);
return result;
}
let arr = [10, 3, 5, 30, 35];
let n = arr.length;
document.write(findGreatest(arr, n));
</script>
|
Time Complexity: O(n3)
Auxiliary Space: O(1)
An efficient method follows below implementation:-
- Create an empty hash table and store all array elements in it.
- Sort the array in ascending order.
- Pick elements one by one from end of the array.
- And check if there exists a pair whose product is equal to that number. In this efficiency can be achieved. The idea is to reach till sqrt of that number. If we don’t get the pair till sqrt that means no such pair exists. We use hash table to make sure that we can find other element of pair in O(1) time.
- Repeat steps 2 to 3 until we get the element or whole array gets traversed.
Below is the implementation.
C++
#include <bits/stdc++.h>
using namespace std;
int findGreatest( int arr[], int n)
{
unordered_map< int , int > m;
for ( int i = 0; i < n; i++)
m[arr[i]]++;
sort(arr, arr + n);
for ( int i = n - 1; i > 1; i--) {
for ( int j = 0; j < i && arr[j] <= sqrt (arr[i]);
j++) {
if (arr[i] % arr[j] == 0) {
int result = arr[i] / arr[j];
if (result != arr[j] && result!=arr[i] && m[result] > 0)
return arr[i];
else if (result == arr[j] && m[result] > 1)
return arr[i];
}
}
}
return -1;
}
int main()
{
int arr[] = {10, 3, 5, 30, 35};
int n = sizeof (arr) / sizeof (arr[0]);
cout << findGreatest(arr, n);
return 0;
}
|
Java
import java.util.*;
class GFG {
static int findGreatest( int arr[], int n)
{
Arrays.sort(arr);
HashMap<Integer, Integer> map = new HashMap<>();
for ( int i = 0 ; i < n; i++)
map.put(arr[i],
map.getOrDefault(arr[i], 0 ) + 1 );
for ( int i = n - 1 ; i > 1 ; i--) {
for ( int j = 0 ;
j < i && arr[j] <= Math.sqrt(arr[i]);
j++) {
if (arr[i] % arr[j] == 0 ) {
int result = arr[i] / arr[j];
if (result != arr[j]
&& map.containsKey(result)) {
if (result == arr[i]) {
if (map.get(arr[i]) > 1 )
return arr[i];
}
else
return arr[i];
}
else if (result == arr[j]
&& map.get(result) > 1 )
return arr[i];
}
}
}
return - 1 ;
}
public static void main(String[] args)
{
int arr[] = { 10 , 3 , 5 , 30 , 35 };
int n = arr.length;
System.out.println(findGreatest(arr, n));
}
}
|
Python
from math import sqrt
def findGreatest(arr, n):
m = dict ()
for i in arr:
m[i] = m.get(i, 0 ) + 1
arr = sorted (arr)
for i in range (n - 1 , 0 , - 1 ):
j = 0
while (j < i and arr[j] < = sqrt(arr[i])):
if (arr[i] % arr[j] = = 0 ):
result = arr[i] / / arr[j]
if (result ! = arr[j] and (result in m.keys()) and m[result] > 0 ):
return arr[i]
elif (result = = arr[j] and (result in m.keys()) and m[result] > 1 ):
return arr[i]
j + = 1
return - 1
arr = [ 10 , 3 , 5 , 30 , 35 ]
n = len (arr)
print (findGreatest(arr, n))
|
C#
using System;
class GFG {
static int findGreatest( int [] arr, int n)
{
int result = -1;
for ( int i = 0; i < n; i++)
for ( int j = 0; j < n - 1; j++)
for ( int k = j + 1; k < n; k++)
if (arr[j] * arr[k] == arr[i])
result = Math.Max(result, arr[i]);
return result;
}
static public void Main()
{
int [] arr = {10, 3, 5, 30, 35 };
int n = arr.Length;
Console.WriteLine(findGreatest(arr, n));
}
}
|
Javascript
<script>
function findGreatest(arr,n)
{
let m = new Map();
for (let i = 0; i < n; i++)
{
if (m.has(arr[i]))
{
m.set(arr[i], m[arr[i]] + 1);
}
else
{
m.set(arr[i], m.get(arr[i]));
}
}
arr.sort( function (a,b){ return a-b;});
for (let i = n - 1; i > 1; i--)
{
for (let j = 0; j < i &&
arr[j] <= Math.sqrt(arr[i]); j++)
{
if (arr[i] % arr[j] == 0)
{
let result = Math.floor(arr[i] / arr[j]);
if (result != arr[j] &&
m[result] == null || m[result] > 0)
{
return arr[i];
}
else if (result == arr[j] && m[result] > 1)
{
return arr[i];
}
}
}
}
return -1;
}
let arr=[10, 3, 5, 30, 35];
let n = arr.length;
document.write(findGreatest(arr, n));
</script>
|
Time Complexity: O(n log n)
Auxiliary Space: O(n)
This article is contributed by Aarti_Rathi and Sahil Chhabra (akku). If you like GeeksforGeeks and would like to contribute, you can also write an article using write.geeksforgeeks.org or mail your article to review-team@geeksforgeeks.org. See your article appearing on the GeeksforGeeks main page and help other Geeks.
Please write comments if you find anything incorrect, or if you want to share more information about the topic discussed above.